//==================================================================
//==================================================================
// Working on:
// 01/02/02 - Get Z-sorting fixed :(
// 16/03/02 - Internal OTs...?
/*==================================================================*/
//==================================================================
#include <psone/gpu.h>
#include <psone/math.h>
#include <psone/syscall.h>
//=======================================================
#define MAX_POLYS 4000
//=======================================================
SVECTOR3D buffer_norm[MAX_POLYS];
SVECTOR3D buffer_3d  [MAX_POLYS];
SVECTOR2D buffer_2d  [MAX_POLYS];
short     buffer_z   [MAX_POLYS];
//=======================================================
MATRIX camera_matrix;
//=======================================================
extern	u_long	* G_GP;
extern	u_long	* OBJECT_prev;
//=======================================================
short	prim_z[MAX_POLYS];
u_long 	prim_number;
u_long 	prim_next[MAX_POLYS];
//=======================================================
void prim_quick_sort ( int s, int e );
//=======================================================
void 	tmd_prim00 ( int type );
void 	tmd_prim20 ( u_long * prim );
void 	tmd_prim22 ( u_long * prim );
void 	tmd_prim24 ( u_long * prim );
void	tmd_prim30 ( u_long * prim );
void	tmd_prim34 ( u_long * prim );
//=======================================================
//=======================================================
void gte_tmd_prim20 ( u_long * primitive );
void gte_tmd_prim34 ( u_long * primitive );
void gte_put_rotation_matrix ( MATRIX * matrix );
void gte_put_vectors ( SVECTOR3D * vector0, SVECTOR3D * vector1, SVECTOR3D * vector2 );
void gte_get_2d_vectors (SVECTOR2D * vector0, SVECTOR2D * vector1, SVECTOR2D * vector2 );
void gte_rtv0tr ( SVECTOR3D * vertex_out, SVECTOR3D * vertex_in, u_long number_of_vertices );
void gte_rtpt   ( void );
long gte_nclip  ( void );
long gte_avsz3  ( void );
//=======================================================
//=======================================================

int    gte_NCLIP (SVECTOR2D * vert0, SVECTOR2D * vert1, SVECTOR2D * vert2);
u_long gte_NCCS  (long rgb_in, SVECTOR3D * norm);
u_long gte_NCCT  (long rgb_in, SVECTOR3D * norm0, SVECTOR3D * norm1, SVECTOR3D * norm2);
void   gte_RTPS  (SVECTOR2D * vert_out, SVECTOR3D * vert_in, u_long n_vert, short * buffer_z);
u_long gte_AVSZ3 (int z1, int z2, int z3);
void   gte_XFORM (SVECTOR3D * vert_out, SVECTOR3D * vert_in, MATRIX * matrix, u_long n_vert);
void   gte_XNORM (SVECTOR3D * norm_out, SVECTOR3D * norm_in, u_long n_norm);

void   gte_set_light_1 (u_char r, u_char g, u_char b);
void   gte_set_light_2 (u_char r, u_char g, u_char b);
void   gte_set_light_3 (u_char r, u_char g, u_char b);

void   GsSetBKColor (u_char r, u_char g, u_char b);
//=======================================================
void internal_set_h(int h);
void internal_set_x(int x);
void internal_set_y(int y);
//=======================================================
static inline void ADD_PACKET (int num, u_long data)
{
    *(G_GP + num + 1) = data;
}
//-------------------------------------------------------
static inline void NEXT_PACKET (int size)
{
    u_long data;
    u_long address = (u_long)(G_GP + size + 1) & 0x00ffffff;
  
    data = (size << 24) | address;

    OBJECT_prev = G_GP;

    *(G_GP) = data;

    G_GP += (size + 1);
}
//-------------------------------------------------------
static inline void SWITCH_ADDRESS (u_long * first, u_long * second)
{
    u_long s1, s2;
    u_long p1, p2;

    s1 = (* first & 0xff000000);
    s2 = (* second & 0xff000000);

    p1 = (* first & 0x00ffffff);
    p2 = (* second & 0x00ffffff);

    * first  = (s1 | p2);
    * second = (s2 | p1);
}

//=======================================================
void GsInit3d(void)
{
	asm volatile ("lui	$4, 0x4000");		
	asm volatile ("mfc0	$5, $12");
	asm volatile ("nop");
	asm volatile ("or	$5, $4");			
	asm volatile ("mtc0	$5, $12");
	asm volatile ("nop");

	asm volatile ("addiu	$8, $0, 0x555");	
	asm volatile ("ctc2	$8, $29");

	asm volatile ("addiu	$8, $0, 0x200");		
	asm volatile ("ctc2	$8, $26");

	asm volatile ("addiu	$9, $0, 0xEF9E");		
	asm volatile ("ctc2	$9, $27");		

	asm volatile ("addiu	$8, $0, 0x140");		
	asm volatile ("ctc2	$8, $28");		 

    GsSet3dOffset (GsDISPENV.disp.w/2, GsDISPENV.disp.h/2);

    GsResetMatrix (&camera_matrix);

}
//=======================================================
void GsSetH(int h)
{
    h &= 0xffff;
    if (h < 0) h = 1;
    internal_set_h(h);
}
//-------------------------------------------------------
void internal_set_h(int h)
{
    
	asm volatile ("add	$8, $0, $4		# Projection plane distance");
	asm volatile ("ctc2	$8, $26			# H = 0x2E8 (600)");
    
}
//-------------------------------------------------------
void GsSetXYZ(int x, int y, int z)
{
    
	asm volatile ("sll	$4, $4, 16		# Make 16.16 fixed point");
	asm volatile ("sll	$5, $5, 16");
	asm volatile ("ctc2	$4, $24			# OFX = (x-res << 16) (Screen offset X)");
	asm volatile ("ctc2	$5, $25			# OFY = (y-res << 16) (Screen offset Y)");
	asm volatile ("add	$8, $0, $6		# Projection plane distance");
	asm volatile ("ctc2	$8, $26			# H = 0x2E8 (600)");
}
//=======================================================
void GsSetBKColor(u_char r, u_char g, u_char b)
{
    
        asm volatile ("sll	$4, $4, 12");
       	asm volatile ("sll	$5, $5, 12");
       	asm volatile ("sll	$6, $6, 12");
        asm volatile ("ctc2	$4, $13			# RBK = (r << 12); (Background red)");
        asm volatile ("ctc2	$5, $14			# GBK = (g << 12); (Background green)");
        asm volatile ("ctc2	$6, $15			# BBK = (b << 12); (Background blue)");
    
}
//=======================================================
void GsSetFogColor(u_char r, u_char g, u_char b)
{
    
       	asm volatile ("sll	$4, $4, 4");
       	asm volatile ("sll	$5, $5, 4");
       	asm volatile ("sll	$6, $6, 4");
        asm volatile ("ctc2	$4, $21			# RFC = (r << 4); (Far color red)");
        asm volatile ("ctc2	$5, $22			# GFC = (g << 4); (Far color green)");
        asm volatile ("ctc2	$6, $23			# BFC = (b << 4); (Far color blue)");
    
}
//=======================================================
void GsSet3dOffset(int x, int y)
{
    
	asm volatile ("sll	$4, $4, 16		# Make 16.16 fixed point");
	asm volatile ("sll	$5, $5, 16");
	asm volatile ("ctc2	$4, $24			# OFX = (x << 16) (Screen offset X)");
	asm volatile ("ctc2	$5, $25			# OFY = (y << 16) (Screen offset Y)");
    
}
//=======================================================
void LoadTmd(TMDHEADER * tmd)
{
    u_long nobj = tmd->nobj;

    TMDOBJECT *object = (TMDOBJECT *)(tmd + 1);

    /* return if it's already been fixed */
    if (tmd->flags & 0x01)
	return;

    /* convert offsets to actual addresses */
    while (nobj--) {

	object->vert_top += (u_long)&(*object);
	object->normal_top += (u_long)&(*object);
	object->primitive_top += (u_long)&(*object);

	object++;
	}

    /* flag that the addresses have been adjusted */
    tmd->flags |= 0x01;

    /* output a warning if we can't handle all those polys */
//    if (object->n_primitive > MAX_POLYS)
//      printf("*WARNING* TMD has more than %d polygons.\n", MAX_POLYS);

    return;
}
//=======================================================
void GsResetMatrix(MATRIX *matrix)
{
    matrix->m[0][0] = matrix->m[1][1] = matrix->m[2][2] = ONE;
    matrix->m[0][1] = matrix->m[0][2] = 0;
    matrix->m[1][0] = matrix->m[1][2] = 0;
    matrix->m[2][0] = matrix->m[2][1] = 0;
}
//=======================================================
void tmd_prim00 (int type)
{
    printf("Unknown TMD primitive. Type = %02x\n", type);
}
//=======================================================
void tmd_prim20 (u_long * prim)
{
    // 'buffer_2d' holds the perspective projected 2d
    // vectors for the poly when we get here...

    u_long flag = (prim[0] >> 16) & 0xff;
    u_long v0, v1, v2;
    u_long n0;
    GsPOLY3 poly;

    if (flag == 0) {

	v0 = prim[2] >> 16;
	v1 = prim[3] & 0xffff;
	v2 = prim[3] >> 16;
	n0 = prim[2] & 0xffff;

	if (gte_NCLIP(&buffer_2d[v0], &buffer_2d[v1], &buffer_2d[v2]) > 0) {

	    poly.x0 = buffer_2d[v0].x;
	    poly.y0 = buffer_2d[v0].y;
	    poly.x1 = buffer_2d[v1].x;
	    poly.y1 = buffer_2d[v1].y;
	    poly.x2 = buffer_2d[v2].x;
	    poly.y2 = buffer_2d[v2].y;

            //gte_NCCS(prim[1], &buffer_norm[n0]);

            poly.r = prim[1] & 0xff;
	    poly.g = (prim[1] >> 8) & 0xff;
	    poly.b = (prim[1] >> 16) & 0xff;

  	    ADD_PACKET (0, 0xe1000200);
  	    ADD_PACKET (1, GPU_COM (0x20, poly.r, poly.g, poly.b));
	    ADD_PACKET (2, H2L (poly.x0, poly.y0));
	    ADD_PACKET (3, H2L (poly.x1, poly.y1));
    	    ADD_PACKET (4, H2L (poly.x2, poly.y2));
	    NEXT_PACKET (5);

	    prim_z[prim_number] = buffer_z[v0] & 0xffff;

	    prim_next[prim_number++] = (u_long)G_GP;

	    }

	}

    else tmd_prim00 (0x20);
}
//=======================================================
void tmd_prim22 (u_long *prim)
{
    // 'buffer_2d' holds the perspective projected 2d
    // vectors for the poly when we get here...

    u_long flag = (prim[0] >> 16) & 0xff;
    u_long v0, v1, v2;
    u_long n0;
    GsPOLY3 poly;

    if (flag == 0) {

	v0 = prim[2] >> 16;
	v1 = prim[3] & 0xffff;
	v2 = prim[3] >> 16;
	n0 = prim[2] & 0xffff;

	poly.x0 = buffer_2d[v0].x;
	poly.y0 = buffer_2d[v0].y;
	poly.x1 = buffer_2d[v1].x;
	poly.y1 = buffer_2d[v1].y;
	poly.x2 = buffer_2d[v2].x;
	poly.y2 = buffer_2d[v2].y;

        //gte_NCCS(prim[1], &buffer_norm[n0]);

	poly.r = prim[1] & 0xff;
	poly.g = (prim[1] >> 8) & 0xff;
	poly.b = (prim[1] >> 16) & 0xff;

	ADD_PACKET (0, 0xe1000200 | (1 << 5) );
	ADD_PACKET (1, GPU_COM (0x22, poly.r, poly.g, poly.b));
	ADD_PACKET (2, H2L (poly.x0, poly.y0));
	ADD_PACKET (3, H2L (poly.x1, poly.y1));
	ADD_PACKET (4, H2L (poly.x2, poly.y2));
	NEXT_PACKET (5);

        prim_z[prim_number] = buffer_z[v0] & 0xffff;
	prim_next[prim_number++] = (u_long)G_GP;

	}

    else tmd_prim00 (0x22);
}
//=======================================================
void tmd_prim24 (u_long *prim)
{
  // 'buffer_2d' holds the perspective projected 2d0
  // vectors for the polys when we get here...

  u_long vertex0, vertex1, vertex2;
  GsTPOLY3 poly;

  poly.r = 0x80;
  poly.g = 0x80;
  poly.b = 0x80;

  vertex0 = prim[4] >> 16;
  vertex1 = prim[5] & 0xffff;
  vertex2 = prim[5] >> 16;

  if (gte_NCLIP(&buffer_2d[vertex0], &buffer_2d[vertex1], &buffer_2d[vertex2]) > 0) {
    poly.x0 = buffer_2d[vertex0].x;
    poly.y0 = buffer_2d[vertex0].y;
    poly.x1 = buffer_2d[vertex1].x;
    poly.y1 = buffer_2d[vertex1].y;
    poly.x2 = buffer_2d[vertex2].x;
    poly.y2 = buffer_2d[vertex2].y;

    poly.u0 = prim[1] & 0xff;
    poly.v0 = (prim[1] >> 8) & 0xff;
    poly.clutid = prim[1] >> 16;
    poly.u1 = prim[2] & 0xff;
    poly.v1 = (prim[2] >> 8) & 0xff;
    poly.tpage = (prim[2] >> 16);
    poly.u2 = prim[3] & 0xff;
    poly.v2 = (prim[3] >> 8) & 0xff;

    ADD_PACKET (0, 0xe1000200);
    ADD_PACKET (1, GPU_COM (0x24, poly.r, poly.g, poly.b));
    ADD_PACKET (2, H2L (poly.x0, poly.y0));
    ADD_PACKET (3, HB2L (poly.clutid, poly.u0, poly.v0));
    ADD_PACKET (4, H2L (poly.x1, poly.y1));
    ADD_PACKET (5, HB2L (poly.tpage, poly.u1, poly.v1));
    ADD_PACKET (6, H2L (poly.x2, poly.y2));
    ADD_PACKET (7, HB2L (0, poly.u2, poly.v2));
    NEXT_PACKET (8);

    prim_z[prim_number] = buffer_z[vertex0] & 0xffff;
    prim_next[prim_number++] = (u_long)G_GP;

  }
}
//=======================================================
void tmd_prim30 (u_long *prim)
{
	// 'buffer_2d' holds the perspective projected 2d
	// vectors for the polys when we get here...

	u_long flag = (prim[0] >> 16) & 0xff;
	u_long v0, v1, v2, n0, n1, n2;
	long rgb;
	GsPOLY3 poly;

	if (flag == 0) {
	  v0 = prim[2] >> 16;
	  v1 = prim[3] >> 16;
	  v2 = prim[4] >> 16;
	  n0 = prim[2] & 0xffff;
	  n1 = prim[3] & 0xffff;
	  n2 = prim[4] & 0xffff;

	  if (gte_NCLIP(&buffer_2d[v0], &buffer_2d[v1], &buffer_2d[v2]) > 0) {
	    poly.x0 = buffer_2d[v0].x;
	    poly.y0 = buffer_2d[v0].y;
	    poly.x1 = buffer_2d[v1].x;
	    poly.y1 = buffer_2d[v1].y;
	    poly.x2 = buffer_2d[v2].x;
	    poly.y2 = buffer_2d[v2].y;

//	    rgb = gte_NCCT(prim[1], &buffer_norm[n0], &buffer_norm[n1], &buffer_norm[n2]);
            rgb = prim[1];
	    poly.r = rgb & 0xff;
	    poly.g = (rgb >> 8) & 0xff;
	    poly.b = (rgb >> 16) & 0xff;

	ADD_PACKET (0, 0xe1000200);
	ADD_PACKET (1, GPU_COM (0x20, poly.r, poly.g, poly.b));
	ADD_PACKET (2, H2L (poly.x0, poly.y0));
	ADD_PACKET (3, H2L (poly.x1, poly.y1));
	ADD_PACKET (4, H2L (poly.x2, poly.y2));
	NEXT_PACKET (5);

        prim_z[prim_number] = buffer_z[v0] & 0xffff;
	prim_next[prim_number++] = (u_long)G_GP;

	    }

	  }

	  else tmd_prim00 (0x30);
}
//=======================================================
void tmd_prim34 (u_long * prim)
{
	// 'buffer_2d' holds the perspective projected 2d
	// vectors for the polys when we get here...

	u_long vertex0, vertex1, vertex2;
	GsGTPOLY3 poly;

	vertex0 = prim[4] >> 16;
	vertex1 = prim[5] >> 16;
	vertex2 = prim[6] >> 16;

//	if (gte_NCLIP(&buffer_2d[vertex0], &buffer_2d[vertex1], &buffer_2d[vertex2]) > 0) {
{
	  poly.r0 = poly.g0 = poly.b0 = 0x80;
	  poly.r1 = poly.g1 = poly.b1 = 0x80;
	  poly.r2 = poly.g2 = poly.b2 = 0x80;

	  poly.x0 = buffer_2d[vertex0].x;
	  poly.y0 = buffer_2d[vertex0].y;
	  poly.x1 = buffer_2d[vertex1].x;
	  poly.y1 = buffer_2d[vertex1].y;
	  poly.x2 = buffer_2d[vertex2].x;
	  poly.y2 = buffer_2d[vertex2].y;

	  poly.u0 = prim[1] & 0xff;
	  poly.v0 = (prim[1] >> 8) & 0xff;
	  poly.u1 = prim[2] & 0xff;
	  poly.v1 = (prim[2] >> 8) & 0xff;
	  poly.u2 = prim[3] & 0xff;
	  poly.v2 = (prim[3] >> 8) & 0xff;

	  poly.tpage = prim[2] >> 16;
	  poly.clutid = prim[1] >> 16;

  	  ADD_PACKET (0, (0xe1000200));
  	  ADD_PACKET (1, GPU_COM (0x34, poly.r0, poly.g0, poly.b0));
  	  ADD_PACKET (2, H2L (poly.x0, poly.y0));
  	  ADD_PACKET (3, HB2L (poly.clutid, poly.u0, poly.v0));
  	  ADD_PACKET (4, GPU_COM (0x00, poly.r1, poly.g1, poly.b1));
  	  ADD_PACKET (5, H2L (poly.x1, poly.y1));
  	  ADD_PACKET (6, HB2L (poly.tpage, poly.u1, poly.v1));
  	  ADD_PACKET (7, GPU_COM (0x00, poly.r2, poly.g2, poly.b2));
  	  ADD_PACKET (8, H2L (poly.x2, poly.y2));
  	  ADD_PACKET (9, HB2L (0, poly.u2, poly.v2));
  	  NEXT_PACKET (10);

	  prim_z[prim_number] = buffer_z[vertex0] & 0xffff;
	  prim_next[prim_number++] = (u_long)G_GP;

	  }
}
//=======================================================
int gte_NCLIP(SVECTOR2D *vert0, SVECTOR2D *vert1, SVECTOR2D *vert2)
{
    register int order;


	asm volatile ("lwc2	$12, (0x0%1)		# upload SXY0");
	asm volatile ("lwc2	$13, (0x0%2)		# upload SXY1");
	asm volatile ("lwc2	$14, (0x0%3)		# upload SXY2");

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("c2	0x1400006		# do the calculations (NCLIP)");
	asm volatile ("mfc2	$2, $24			# return the result (MAC0)");

	asm volatile ("": "=r"( order ): "r"( vert0 ), "r"( vert1 ), "r"( vert2 ));

    return (order);
}
//=======================================================
u_long gte_NCCT(long rgb_in, SVECTOR3D *norm0, SVECTOR3D *norm1, SVECTOR3D *norm2)
{
	register u_long rgb_out;
	

		asm volatile ("li	$2, 0x10000000		# ONE (4096)");
		asm volatile ("li	$3, 0x00001000		# ONE (4096)");
		asm volatile ("li	$8, 0x10001000		# ONE (4096)");

		asm volatile ("ctc2	$8, $8			# $8 = 11	light source matrix");
		asm volatile ("ctc2	$8, $9			# $9 = 00");
		asm volatile ("ctc2	$8, $10			# $10 = 10");
		asm volatile ("ctc2	$8, $11			# $11 = 00");
		asm volatile ("ctc2	$8, $12			# $12 = 10");

		asm volatile ("ctc2	$3, $16			# $16 = 10	light color matrix");
		asm volatile ("ctc2	$3, $17			# $17 = 00	R R R");
		asm volatile ("ctc2	$0, $18			# $18 = 00	G G G");
		asm volatile ("ctc2	$0, $19			# $19 = 00	B B B");
		asm volatile ("ctc2	$0, $20			# $20 = 00");
		
		asm volatile ("lwc2	$0, 0x0%2		# VXY0 = x/y of normal 0");
		asm volatile ("lwc2	$1, 0x4%2		# VZ0 = z of normal 0");
		asm volatile ("lwc2	$2, 0x0%3		# VXY1 = x/y of normal 1");
		asm volatile ("lwc2	$3, 0x4%3		# VZ1 = z of normal 1");
		asm volatile ("lwc2	$4, 0x0%4		# VXY2 = x/y of normal 2");
		asm volatile ("lwc2	$5, 0x4%4		# VZ2 = z of normal 2");
		asm volatile ("mtc2	$4, $6			# RGB = rgb_in");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x118043f		# do the calculations (NCCT)");
		asm volatile ("mfc2	$2, $22			# return the result (RGBn)");

		asm volatile ("": "=r"( rgb_out ): "r"( rgb_in ), "r"( norm0 ), "r"( norm1 ), "r"( norm2 ));

	return (rgb_out);
}
//=======================================================
//in:      SZ1, SZ2, SZ3     Z-Values
//         ZSF3              Divider
//out:     OTZ               Average
//	   MAC0              Average

u_long gte_AVSZ3 (int z1, int z2, int z3)
{
	register u_long average;
	

		asm volatile ("mtc2	$1, $17");
		asm volatile ("mtc2	$2, $18");
		asm volatile ("mtc2	$3, $19");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x158002D");
		asm volatile ("mfc2	$2, $7");
		asm volatile ("": "=r"( average ): "r"( z1 ), "r"( z2 ), "r"( z3 ));

	return (average);
}
//=======================================================
u_long gte_NCCS ( long rgb_in, SVECTOR3D *norm )
{
	register u_long rgb_out;

		asm volatile ("li	$2, 0x10001000		# ONE (4096)");
		asm volatile ("li	$3, 0x00001000		# ONE (4096)");

		asm volatile ("ctc2	$2, $8			# $8 = 11	light source matrix");
		asm volatile ("ctc2	$2, $9			# $9 = 11");
		asm volatile ("ctc2	$2, $10			# $10 = 11");
		asm volatile ("ctc2	$2, $11			# $11 = 11");
		asm volatile ("ctc2	$2, $12			# $12 = 11");

		asm volatile ("ctc2	$2, $16			# $16 = 10	light color matrix");
		asm volatile ("ctc2	$3, $17			# $17 = 00");
		asm volatile ("ctc2	$3, $18			# $18 = 10");
		asm volatile ("ctc2	$3, $19			# $19 = 00");
		asm volatile ("ctc2	$3, $20			# $20 = 10");
		
		asm volatile ("lwc2	$0, 0x0%2		# VXY0 = x/y of normal");
		asm volatile ("lwc2	$1, 0x4%2		# VZ0 = z of normal");
		asm volatile ("mtc2	$1, $6			# RGB = rgb_in");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x108041b		# do the calculations (NCCS)");
		asm volatile ("mfc2	$2, $22			# return the result (RGBn)");

		asm volatile ("": "=r"( rgb_out ): "r"( rgb_in ), "r"( norm ));

	return (rgb_out);
}
//=======================================================
void gte_RTPS ( SVECTOR2D * vert_out, SVECTOR3D * vert_in, u_long n_vert, short * buffer_z )
{
	

	 asm volatile ("project_vertex:");

		asm volatile ("lwc2	$0, 0x0($5)		# VXY0 = x/y of vertex");
		asm volatile ("lwc2	$1, 0x4($5)		# VZ0 = z of vertex");
	
		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x0180001		# do the calculation (RTPS)");

		asm volatile ("mfc2	$2, $14			# $2 = SXYP (projected X/Y coordinates)");
		asm volatile ("mfc2	$8, $19			# $2 = SZ3 (projected Z coordinate)");

		asm volatile ("sra	$3, $2, 0x10		# v1 = Y");
		asm volatile ("andi	$2, $2, 0xffff		# v0 = X");
		asm volatile ("andi	$8, $8, 0xffff		# Z");

		asm volatile ("sh	$2, 0x0($4)		# Store projected X");
		asm volatile ("sh	$3, 0x2($4)		# Store projected Y");
		asm volatile ("sh	$8, 0x0($7)		# Store projected Z");

		asm volatile ("addu	$4, $4, 0x4		# Next destination vertex");
		asm volatile ("addu	$5, $5, 0x8		# Next source vertex");
		asm volatile ("addu	$7, $7, 0x2		# Next source vertex");

		asm volatile ("sub	$6, $6, 1");
		asm volatile ("bnez	$6, project_vertex");

		asm volatile ("":: "r"( vert_out ), "r"( vert_in ), "r"( n_vert));

}
//=======================================================
//=======================================================
/* load rotation matrix into the GTE */
void gte_put_rotation_matrix (MATRIX * matrix)
{

		asm volatile ("lw	$8,   0($4)");
		asm volatile ("lw	$9,   4($4)");
		asm volatile ("lw	$10,  8($4)");
		asm volatile ("lw	$11, 12($4)");
		asm volatile ("lw	$12, 16($4)");
		asm volatile ("lw	$15, 20($4)");
		asm volatile ("lw	$24, 24($4)");
		asm volatile ("lw	$25, 28($4)");

		asm volatile ("ctc2	$8,  $0			# R11R12 = matrix.m[0][0]/[0][1]");
		asm volatile ("ctc2	$9,  $1			# R13R21 = matrix.m[0][2]/[1][0]");
		asm volatile ("ctc2	$10, $2			# R22R23 = matrix.m[1][1]/[1][2]");
		asm volatile ("ctc2	$11, $3			# R31R32 = matrix.m[2][0]/[2][1]");
		asm volatile ("ctc2	$12, $4			# R33    = matrix.m[2][2]");
		asm volatile ("ctc2	$15, $5			# TRX = matrix.t[0]");
		asm volatile ("ctc2	$24, $6			# TRX = matrix.t[0]");
		asm volatile ("ctc2	$25, $7			# TRX = matrix.t[0]");

		asm volatile ("":: "r"( matrix ));
}
//=======================================================
//=======================================================
/* load vectors into the GTE */
void gte_put_vectors (SVECTOR3D * vector0, SVECTOR3D * vector1, SVECTOR3D * vector2)
{

		asm volatile ("lwc2	$0, 0($4)		# VXY0 = x/y of vertex 0");
		asm volatile ("lwc2	$1, 4($4)		# VZ0 = z of vertex 0");

		asm volatile ("lwc2	$2, 0($5)		# VXY1 = x/y of vertex 1");
		asm volatile ("lwc2	$3, 4($5)		# VZ1 = z of vertex 1");

		asm volatile ("lwc2	$4, 0($6)		# VXY2 = x/y of vertex 2");
		asm volatile ("lwc2	$5, 4($6)		# VZ2 = z of vertex 2");

		asm volatile ("":: "r"( vector0 ), "r"( vector1 ), "r"( vector2 ));
}
//=======================================================
//=======================================================
/* get the 2d projected vectors from the GTE */
void gte_get_2d_vectors (SVECTOR2D * vector0, SVECTOR2D * vector1, SVECTOR2D * vector2 )
{

		asm volatile ("mfc2	$7, $12");
		asm volatile ("mfc2	$8, $13");
		asm volatile ("mfc2	$9, $14");

		asm volatile ("sw	$7, 0($4)");
		asm volatile ("sw	$8, 0($5)");
		asm volatile ("sw	$9, 0($6)");

		asm volatile ("":: "r"( vector0 ),"r"( vector1 ), "r"( vector2 ));
}
//=======================================================
//=======================================================
void gte_rtv0tr (SVECTOR3D * vertex_out, SVECTOR3D * vertex_in, u_long number_of_vertices)
{

	asm volatile ("gte_rtv0tr_loop:");
		asm volatile ("lwc2	$0, 0($5)		# VXY0 = x/y of vertex");
		asm volatile ("lwc2	$1, 4($5)		# VZ0 = z of vertex");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x480012		# do the gte calculation (rtv0tr)");

		asm volatile ("mfc2	$8,  $9");
		asm volatile ("mfc2	$9,  $10");
		asm volatile ("mfc2	$10, $11");
		asm volatile ("sh	$8,  0($4)		# vect_out.x = IR1");
		asm volatile ("sh	$9,  2($4)		# vect_out.y = IR2");
		asm volatile ("sh	$10, 4($4)		# vect_out.z = IR3");

		asm volatile ("addiu	$4, $4, 0x8		# Next destination vector");
		asm volatile ("addiu	$5, $5, 0x8		# Next source vector");

		asm volatile ("sub	$6, $6, 1");
		asm volatile ("bnez	$6, gte_rtv0tr_loop");

		asm volatile ("":: "r"( vertex_out ), "r"( vertex_in ), "r"( number_of_vertices));
}
//=======================================================
//=======================================================
void gte_rtpt ( void )
{

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x0280030		# do the gte calculation (rtpt)");

		asm volatile (""::);

}
//=======================================================
//=======================================================
long gte_nclip ( void )
{
    register int direction;

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("c2	0x1400006		# do the gte calculation (nclip)");
	asm volatile ("mfc2	$2, $24			# return the result (mac0)");

	asm volatile ("": "=r"( direction ):);

    return (direction);
}
//=======================================================
//=======================================================
long gte_avsz3  ( void )
{
    register long average_z;

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("c2	0x158002d");
	asm volatile ("mfc2	$2, $7");
	asm volatile ("": "=r"( average_z ):);

    return (average_z);
}
//=======================================================
//=======================================================
void gte_tmd_prim20 (u_long * primitive)
{
    u_long flag = (primitive[0] >> 16) & 4;
    u_long vector0, vector1, vector2;
    u_long normal0;
    GsPOLY3 poly;
    SVECTOR2D v0, v1, v2;

    if (flag == 0) {

	vector0 = primitive[2] >> 16;
	vector1 = primitive[3] & 0xffff;
	vector2 = primitive[3] >> 16;
	normal0 = primitive[2] & 0xffff;

	gte_put_vectors ( &buffer_3d[vector0], &buffer_3d[vector1], &buffer_3d[vector2] );

	gte_rtpt();

	if (gte_nclip () > 0) {
	    
	    prim_z[prim_number] = gte_avsz3 ();

	    gte_get_2d_vectors ( &v0, &v1, &v2 );

	    poly.x0 = v0.x;
	    poly.y0 = v0.y;
	    poly.x1 = v1.x;
	    poly.y1 = v1.y;
	    poly.x2 = v2.x;
	    poly.y2 = v2.y;

            //gte_NCCS(prim[1], &buffer_norm[n0]);

            poly.r = primitive[1] & 0xff;
	    poly.g = (primitive[1] >> 8) & 0xff;
	    poly.b = (primitive[1] >> 16) & 0xff;

  	    ADD_PACKET (0, 0xe1000200);
  	    ADD_PACKET (1, GPU_COM (0x20, poly.r, poly.g, poly.b));
	    ADD_PACKET (2, H2L (poly.x0, poly.y0));
	    ADD_PACKET (3, H2L (poly.x1, poly.y1));
    	    ADD_PACKET (4, H2L (poly.x2, poly.y2));
	    NEXT_PACKET (5);

	    prim_next[prim_number++] = (u_long)G_GP;

	    }

	}

    else tmd_prim00 (0x20);
}
//=======================================================
void gte_tmd_prim34 (u_long * primitive)
{
    u_long vector0, vector1, vector2;
    GsGTPOLY3 poly;
    SVECTOR2D v0, v1, v2;

    vector0 = primitive[4] >> 16;
    vector1 = primitive[5] >> 16;
    vector2 = primitive[6] >> 16;

    gte_put_vectors ( &buffer_3d[vector0], &buffer_3d[vector1], &buffer_3d[vector2] );

    gte_rtpt();

    if (gte_nclip () > 0) {

	prim_z[prim_number] = gte_avsz3 ();

	gte_get_2d_vectors ( &v0, &v1, &v2 );

	poly.x0 = v0.x;
	poly.y0 = v0.y;
	poly.x1 = v1.x;
	poly.y1 = v1.y;
	poly.x2 = v2.x;
	poly.y2 = v2.y;

	poly.r0 = poly.g0 = poly.b0 = 0x80;
	poly.r1 = poly.g1 = poly.b1 = 0x80;
	poly.r2 = poly.g2 = poly.b2 = 0x80;

	poly.u0 = primitive[1] & 0xff;
	poly.v0 = (primitive[1] >> 8) & 0xff;
	poly.u1 = primitive[2] & 0xff;
	poly.v1 = (primitive[2] >> 8) & 0xff;
	poly.u2 = primitive[3] & 0xff;
	poly.v2 = (primitive[3] >> 8) & 0xff;

	poly.tpage = primitive[2] >> 16;
	poly.clutid = primitive[1] >> 16;

  	ADD_PACKET (0, (0xe1000200));
  	ADD_PACKET (1, GPU_COM (0x34, poly.r0, poly.g0, poly.b0));
  	ADD_PACKET (2, H2L (poly.x0, poly.y0));
  	ADD_PACKET (3, HB2L (poly.clutid, poly.u0, poly.v0));
  	ADD_PACKET (4, GPU_COM (0x00, poly.r1, poly.g1, poly.b1));
  	ADD_PACKET (5, H2L (poly.x1, poly.y1));
  	ADD_PACKET (6, HB2L (poly.tpage, poly.u1, poly.v1));
  	ADD_PACKET (7, GPU_COM (0x00, poly.r2, poly.g2, poly.b2));
  	ADD_PACKET (8, H2L (poly.x2, poly.y2));
  	ADD_PACKET (9, HB2L (0, poly.u2, poly.v2));
  	NEXT_PACKET (10);

	prim_next[prim_number++] = (u_long)G_GP;

	}
}
//=======================================================
//=======================================================

void gte_XFORM(SVECTOR3D *vert_out, SVECTOR3D *vert_in, MATRIX *matrix, u_long n_vert)
{

		asm volatile ("lw	$8,  0x0($6)");
		asm volatile ("lw	$9,  0x04($6)");
		asm volatile ("lw	$10, 0x08($6)");
		asm volatile ("lw	$11, 0x0C($6)");
		asm volatile ("lw	$12, 0x10($6)");
		asm volatile ("ctc2	$8,  $0			# R11R12 = matrix.m[0][0]/[0][1]");
		asm volatile ("ctc2	$9,  $1			# R13R21 = matrix.m[0][2]/[1][0]");
		asm volatile ("ctc2	$10, $2			# R22R23 = matrix.m[1][1]/[1][2]");
		asm volatile ("ctc2	$11, $3			# R31R32 = matrix.m[2][0]/[2][1]");
		asm volatile ("ctc2	$12, $4			# R33    = matrix.m[2][2]");

		asm volatile ("lw	$15, 0x14($6)");
		asm volatile ("lw	$24, 0x18($6)");
		asm volatile ("lw	$25, 0x1C($6)");
		asm volatile ("ctc2	$15, $5			# TRX = matrix.t[0]");
		asm volatile ("ctc2	$24, $6			# TRX = matrix.t[0]");
		asm volatile ("ctc2	$25, $7			# TRX = matrix.t[0]");

	asm volatile ("transform_vertex:");
		asm volatile ("lwc2	$0, 0x0($5)		# VXY0 = x/y of vertex");
		asm volatile ("lwc2	$1, 0x4($5)		# VZ0 = z of vertex");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x480012		# do the calculation (RTV0TR)");

		asm volatile ("mfc2	$8,  $9");
		asm volatile ("mfc2	$9,  $10");
		asm volatile ("mfc2	$10, $11");
		asm volatile ("sh	$8,  0x0($4)		# vect_out.x = IR1");
		asm volatile ("sh	$9,  0x2($4)		# vect_out.y = IR2");
		asm volatile ("sh	$10, 0x4($4)		# vect_out.z = IR3");

		asm volatile ("addiu	$4, $4, 0x8		# Next destination vector");
		asm volatile ("addiu	$5, $5, 0x8		# Next source vector");

		asm volatile ("sub	$7, $7, 1");
		asm volatile ("bnez	$7, transform_vertex");

		asm volatile ("":: "r"( vert_out ), "r"( vert_in ), "r"( matrix ),  "r"( n_vert));
}
//=======================================================
// Must be called directly after gte_XFORM, so that the 
// rotation matrix is still loaded in the GTE.
//
void gte_XNORM(SVECTOR3D *norm_out, SVECTOR3D *norm_in, u_long n_norm)
{
	

	asm volatile ("transform_normal:");
		asm volatile ("lwc2	$0, 0x0($5)		# VXY0 = x/y of normal");
		asm volatile ("lwc2	$1, 0x4($5)		# VZ0 = z of normal");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x480012		# do the calculation (RTV0TR)");

		asm volatile ("mfc2	$8,  $9");
		asm volatile ("mfc2	$9,  $10");
		asm volatile ("mfc2	$10, $11");
		asm volatile ("sh	$8,  0x0($4)		# norm_out.x = IR1");
		asm volatile ("sh	$9,  0x2($4)		# norm_out.y = IR2");
		asm volatile ("sh	$10, 0x4($4)		# norm_out.z = IR3");

		asm volatile ("addiu	$4, $4, 0x8		# Next destination normal");
		asm volatile ("addiu	$5, $5, 0x8		# Next source normal");

		asm volatile ("sub	$6, $6, 1");
		asm volatile ("bnez	$6, transform_normal");

		asm volatile ("":: "r"( norm_out ), "r"( norm_in ), "r"( n_norm));

}
//=======================================================
void MulMatrix0 (MATRIX *m0, MATRIX *m1, MATRIX *m2)
{

		asm volatile ("li	$3,  0xFFFF0000");

		asm volatile ("lw	$8,  0x0($6)");
		asm volatile ("lw	$9,  0x04($6)");
		asm volatile ("lw	$10, 0x08($6)");
		asm volatile ("lw	$11, 0x0C($6)");
		asm volatile ("lw	$12, 0x10($6)");
		asm volatile ("ctc2	$8,  $0			# R11R12 = matrix m2.m[0][0]/[0][1]");
		asm volatile ("ctc2	$9,  $1			# R13R21 = matrix m2.m[0][2]/[1][0]");
		asm volatile ("ctc2	$10, $2			# R22R23 = matrix m2.m[1][1]/[1][2]");
		asm volatile ("ctc2	$11, $3			# R31R32 = matrix m2.m[2][0]/[2][1]");
		asm volatile ("ctc2	$12, $4			# R33    = matrix m2.m[2][2]");

		asm volatile ("lhu	$8,  0x0($5)		# first vector of m1");
		asm volatile ("lw	$9,  0x4($5)");
		asm volatile ("lw	$10, 0xC($5)");
		asm volatile ("and	$9,  $9, $3");
		asm volatile ("or	$8,  $8, $9");

		asm volatile ("mtc2	$8,  $0			# SXY0 = $8");
		asm volatile ("mtc2	$10, $1			# SZ0 = $10");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x486012		# do the calculation (RTV0)");

		asm volatile ("lhu	$8,  0x2($5)		# second vector of m1");
		asm volatile ("lw	$9,  0x8($5)");
		asm volatile ("lh	$10, 0xE($5)");
		asm volatile ("sll	$9, $9, 16");
		asm volatile ("or	$8, $8, $9");

		asm volatile ("mfc2	$11, $9			# $11 = IR1");
		asm volatile ("mfc2	$12, $10		# $12 = IR2");
		asm volatile ("mfc2	$13, $11		# $13 = IR3");

		asm volatile ("mtc2	$8,  $0			# SXY0 = $8");
		asm volatile ("mtc2	$10, $1			# SZ0 = $10");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x486012		# do the calculation (RTV0)");

		asm volatile ("lhu	$8,  0x04($5)		# third vector of m1");
		asm volatile ("lw	$9,  0x08($5)");
		asm volatile ("lw	$10, 0x10($5)");
		asm volatile ("and	$9,  $9, $3");
		asm volatile ("or	$8,  $8, $9");

		asm volatile ("mfc2	$14, $9			# $14 = IR1");
		asm volatile ("mfc2	$15, $10		# $15 = IR2");
		asm volatile ("mfc2	$24, $11		# $24 = IR3");

		asm volatile ("mtc2	$8,  $0			# SXY0 = $8");
		asm volatile ("mtc2	$10, $1			# SZ0 = $10");

		asm volatile ("nop");
		asm volatile ("nop");
		asm volatile ("c2	0x486012		# do the calculation (RTV0)");

		asm volatile ("mfc2	$8, $9			# Get third result");
		asm volatile ("mfc2	$9, $10");

		asm volatile ("andi	$11, $11, 0xffff	# Assemble and write back the result");
		asm volatile ("sll	$14, $14, 16");
		asm volatile ("or	$14, $14, $11");
		asm volatile ("sw	$14, 0x00($4)");

		asm volatile ("andi	$13, $13, 0xffff	# Assemble and write back the result");
		asm volatile ("sll	$24, $24, 16");
		asm volatile ("or	$24, $24, $13");
		asm volatile ("sw	$24, 0x0C($4)");

		asm volatile ("andi	$8, $8, 0xffff		# Assemble and write back the result");
		asm volatile ("sll	$12, $12, 16");
		asm volatile ("or	$8, $8, $12");
		asm volatile ("sw	$8, 0x04($4)");

		asm volatile ("andi	$15, $15, 0xffff	# Assemble and write back the result");
		asm volatile ("sll	$9, $9, 16");
		asm volatile ("or	$9, $9, $15");
		asm volatile ("sw	$9, 0x08($4)");

		asm volatile ("swc2	$11, 0x10($4)		# This one comes straight from the GTE");
		asm volatile ("":: "r"( m0 ), "r"( m1 ), "r"( m2 ));
}
//=======================================================
void GsSetFlatLight(int id, GsF_LIGHT *light)
{
	
	if (id == 1) {
	  gte_set_light_1(light->r, light->g, light->b);
	  }

	if (id == 2) {
	  gte_set_light_2(light->r, light->g, light->b);
	  }

	if (id == 3) {
	  gte_set_light_3(light->r, light->g, light->b);
	  }

//	light->vx = 20;
//	light->vy = -100;
//	light->vz = -100;

//   GsSetAmbient(0, 0, 0);
//   GsSetLightMode(0);
}
//=======================================================
void gte_set_light_1(u_char r, u_char g, u_char b)
{
	
		asm volatile ("cfc2	$8, $16			# t0 = LR2|LR1");
		asm volatile ("cfc2	$9, $17			# t1 = LG1|LR3");
		asm volatile ("cfc2	$10, $19		# t2 = LB2|LB1");

		asm volatile ("sll	$4, $4, 6");
		asm volatile ("sll	$5, $5, 21");
		asm volatile ("sll	$6, $6, 6");

		asm volatile ("andi	$4, $4, 0xffff");
		asm volatile ("andi	$6, $6, 0xffff");

		asm volatile ("and	$8, $8, $4");
		asm volatile ("and	$9, $9, $5");
		asm volatile ("and	$10, $10, $6");

	        asm volatile ("ctc2	$8, $16");
	        asm volatile ("ctc2	$9, $17");
	        asm volatile ("ctc2	$10, $19");
}
//=======================================================
void gte_set_light_2(u_char r, u_char g, u_char b)
{
	
		asm volatile ("cfc2	$8, $16			# t0 = LR2|LR1");
		asm volatile ("cfc2	$9, $18			# t1 = LG3|LG2");
		asm volatile ("cfc2	$10, $19		# t2 = LB2|LB1");

		asm volatile ("sll	$4, $4, 20");
		asm volatile ("sll	$5, $5, 4");
		asm volatile ("sll	$6, $6, 20");

		asm volatile ("andi	$5, $5, 0xffff");

		asm volatile ("and	$8, $8, $4");
		asm volatile ("and	$9, $9, $5");
		asm volatile ("and	$10, $10, $6");

	        asm volatile ("ctc2	$8, $16");
	        asm volatile ("ctc2	$9, $18");
	        asm volatile ("ctc2	$10, $19");
	
}
//=======================================================
void gte_set_light_3(u_char r, u_char g, u_char b)
{
	
		asm volatile ("cfc2	$8, $17			# t0 = LG1|LR3");
		asm volatile ("cfc2	$9, $18			# t1 = LG3|LR2");
		asm volatile ("cfc2	$10, $20		# t2 =   0|LB3");

		asm volatile ("sll	$4, $4, 4");
		asm volatile ("sll	$5, $5, 20");
		asm volatile ("sll	$6, $6, 4");

		asm volatile ("andi	$4, $4, 0xffff");
		asm volatile ("andi	$6, $6, 0xffff");

		asm volatile ("and	$8, $8, $4");
		asm volatile ("and	$9, $9, $5");
		asm volatile ("and	$10, $10, $6");

	        asm volatile ("ctc2	$8, $17");
	        asm volatile ("ctc2	$9, $18");
	        asm volatile ("ctc2	$10, $20");
	
}
//=======================================================
long GsSortObject2(GsOBJECT * object)
{
  MATRIX temp_matrix, rotate_matrix;

  TMDHEADER * tmd = (TMDHEADER *)(object->model);
  TMDOBJECT * obj = (TMDOBJECT *)(tmd + 1);
  u_long * prim = (u_long *)obj->primitive_top;
  u_long n_prim = obj->n_primitive;
  int type;
  int sx, sy, sz, cx, cy, cz;
  //int i;
  u_long prim_last;
  u_long prim_f;
  u_long * prim_first;

  prim = (u_long *)obj->primitive_top;
  n_prim = obj->n_primitive;

  prim_number = 0;

  /* Set up the rotation and translation matrices for the GTE */

  GsResetMatrix(&temp_matrix);
  GsResetMatrix(&rotate_matrix);

  object->rx &= 0xfff;
  object->ry &= 0xfff;
  object->rz &= 0xfff;

  /* z axis rotation */
  if (object->rz) {
     sz = sin(object->rz);
     cz = cos(object->rz);
     rotate_matrix.m[0][0] = rotate_matrix.m[1][1] = cz;
     rotate_matrix.m[0][1] = sz;
     rotate_matrix.m[1][0] = -sz;
     MulMatrix0(&rotate_matrix, &rotate_matrix, &temp_matrix);
     }
        
  /* y axis rotation */
  if (object->ry) {
     sy = sin(object->ry);
     cy = cos(object->ry);
     temp_matrix.m[0][0] = temp_matrix.m[2][2] = cy;
     temp_matrix.m[0][2] = -sy;
     temp_matrix.m[2][0] = sy;
     MulMatrix0(&rotate_matrix, &rotate_matrix, &temp_matrix);
     }

  /* x axis rotation */
  if (object->rx) {
     sx = sin(object->rx);
     cx = cos(object->rx);
     GsResetMatrix(&temp_matrix);
     temp_matrix.m[1][1] = temp_matrix.m[2][2] = cx;
     temp_matrix.m[1][2] = sx;
     temp_matrix.m[2][1] = -sx;
     MulMatrix0(&rotate_matrix, &rotate_matrix, &temp_matrix);
     }
   
   rotate_matrix.t[0] = object->x;
   rotate_matrix.t[1] = object->y;
   rotate_matrix.t[2] = object->z;

   /* rotate the object */
   gte_put_rotation_matrix (&rotate_matrix);
   gte_rtv0tr (buffer_3d, (SVECTOR3D *)obj->vert_top, obj->n_vert);

   /* apply the camera position */
   gte_put_rotation_matrix (&camera_matrix);
   gte_rtv0tr (buffer_3d, buffer_3d, obj->n_vert);

   /* work out the normals */
   //gte_XNORM(buffer_norm, (SVECTOR3D *)obj->normal_top, obj->n_normal);

   /* do perspective projection */
   //gte_RTPS(buffer_2d, buffer_3d, obj->n_vert, buffer_z);
     
   prim_first = G_GP;

   while (n_prim--) {

     type = (prim[0] >> 24);

     switch (type) {

	case 0x20:  gte_tmd_prim20 (prim);
		    break;
	case 0x22:  tmd_prim22 (prim);
		    break;
	case 0x24:  tmd_prim24 (prim);
		    break;
	case 0x30:  tmd_prim30 (prim);
		    break;
	case 0x34:  gte_tmd_prim34 (prim);
		    break;
	case 0x36:  tmd_prim34 (prim);
		    break;
	default:    tmd_prim00 (type);

       }

     prim += ((prim[0] >> 8) & 0xff) + 1;

     }

/**************************************************************/
/*
  printf("=============================\n");
  printf("= BEFORE\n");
  printf("[<] %08x ---> %08x\n", prim_first, *(prim_first) );
  for (i = 0; i < prim_number; i++) {
     printf("[%d] %08x ---> %08x (z=%04x)\n", i, &prim_next[i], prim_next[i], prim_z[i] );
     }  
*/
  prim_last = prim_next[prim_number-1];

if (prim_last) {

  prim_f = *(prim_first);

  //printf(">>> %08x, %08x - %08x\n", prim_first, prim_f, prim_last);

  prim_quick_sort(0, prim_number - 1);

  //for (i = 0; i < prim_number; i++) {
    //SWITCH_ADDRESS (prim_next[i-1], prim_next[i]);
  //}

  //* (prim_next[prim_number-1]) = prim_last;

  //SWITCH_ADDRESS (prim_next[prim_number-1], &prim_last);

  prim_next[prim_number-1] = prim_last;

  //* prim_first = * (prim_next[0]);
  //SWITCH_ADDRESS (prim_first, prim_next[0] );
  * prim_first = prim_f;

  }
/*
  printf("-----------------------------\n");
  printf("- AFTER\n");
  printf("[<] %08x ---> %08x\n", prim_first, *(prim_first) );
  for (i = 0; i < prim_number; i++) {
     printf("[%d] %08x ---> %08x (z=%04x)\n", i, &prim_next[i], (u_long *)&prim_next[i], prim_z[i] );
     }
  printf(">>> %08x, %08x - %08x\n", prim_first, prim_f, prim_last);
*/
/****************************************************************/
    return(prim_z[0]);

}
//=======================================================
void GsSetView(GsCAMERA *camera)
{
  MATRIX temp_matrix;

  int sx, sy, sz, cx, cy, cz;
  
  GsResetMatrix(&temp_matrix);
  GsResetMatrix(&camera_matrix);

  camera->ax &= 0xfff;
  camera->ay &= 0xfff;
  camera->az &= 0xfff;

  /* y axis rotation */
  if (camera->ay) {
     sy = sin(-camera->ay);
     cy = cos(camera->ay);
     camera_matrix.m[0][0] = camera_matrix.m[2][2] = cy;
     camera_matrix.m[0][2] = -sy;
     camera_matrix.m[2][0] = sy;
     }

  /* x axis rotation */
  if (camera->ax) {
     sx = sin(-camera->ax);
     cx = cos(camera->ax);
     temp_matrix.m[1][1] = temp_matrix.m[2][2] = cx;
     temp_matrix.m[1][2] = sx;
     temp_matrix.m[2][1] = -sx;
     MulMatrix0(&camera_matrix, &camera_matrix, &temp_matrix);
     }
   
  /* z axis rotation */
  if (camera->az) {
     sz = sin(-camera->az);
     cz = cos(camera->az);
     GsResetMatrix(&temp_matrix);
     temp_matrix.m[0][0] = temp_matrix.m[1][1] = cz;
     temp_matrix.m[0][1] = sz;
     temp_matrix.m[1][0] = -sz;
     MulMatrix0(&camera_matrix, &camera_matrix, &temp_matrix);
     }
  
  camera_matrix.t[0] = -(camera->x);
  camera_matrix.t[1] = -(camera->y);
  camera_matrix.t[2] = -(camera->z);
}
//=======================================================
void prim_quick_sort(int s, int e)
{
  long h, g, l, r;

  if (s < e) {
    g = prim_z[s + (e - s) / 2];
    l = s;
    r = e;

    while (l < r) {

      // This quick sort is descending, so that the largest Z coordinate is drawn first.
      // For an ascending sort, reverse all the < and > signs in the following 2 lines
      while ( (prim_z[l] > g) && (l <= e) ) l++;
      while ( (prim_z[r] < g) && (r >= s) ) r--;

      if (l <= r) {

        h = prim_z[l];
        prim_z[l] = prim_z[r];
        prim_z[r] = h;

	SWITCH_ADDRESS (&prim_next[l], &prim_next[r]);

        l++;
        r--;

        }

      }

    prim_quick_sort(s, r);
    prim_quick_sort(l, e);
    }

}
