#include <psone/bladeps.h>
#include <psone/pslib/libspu.h>
#include <psone/pslib/hwreg.h>

#define X 		320 
#define Y 		240

#define SPACE		8

#define BUF_SIZE	(X*Y)
#define MAX_XCURSOR 	(X/SPACE) - 2
#define MAX_YCURSOR 	(Y/SPACE) - 2
#define MAX_SCREENDIGIT (MAX_XCURSOR * MAX_YCURSOR)


#define R 40
#define G 40
#define B 100

void Graphic_Init();
void ScreenUpdate();
void ScreenClear();
void PrintValue(int value);
void PrintCharacter(char ch);
void PrintString(char * string);
void CursorCheck();
void BufferUpdate();
void BufferSave();
void ScreenBackground();

int check = 1;
u_long gpu_buffer[2][4000];
char char_buffer[MAX_XCURSOR + 1][MAX_YCURSOR + 1];


int act = 0;
int x = 0;
int y = 0; 
int xcursor = 1;
int ycursor = 1;

int counter = 0;


void PrintValue(int value)
{
	CursorCheck();
	ScreenClear();
	
	ScreenBackground();
	FntPrint(0, x, y, "%d", value);
	char_buffer[xcursor-1][ycursor-1] = atoi(value);
	

	ScreenUpdate();

}


void PrintCharacter(char ch)
{
u_long pad = 0;

	act = GsGetActiveBuff ();

	CursorCheck();
	ScreenClear();
 	ScreenBackground();
 	char_buffer[xcursor-1][ycursor-1] = ch;	
	ScreenUpdate();


}

void PrintString(char * string)
{
int index = 0;

	while(1)
	{
		if(string[index] == '\0') break;

//  		if(index == MAX_SCREENDIGIT - 1)
// 		{
// 			ScreenClear();
// 			ScreenUpdate();
// 		}
	
		if(string[index] == '\n')
		{
				CursorCheck();
				x = 0; xcursor = 1 ; y += SPACE;ycursor++;
		}
		
		PrintCharacter(string[index]);

 		index++;
	}
	

}

void ScreenUpdate()
{	
	GsSwapDispBuff();
 	GsDrawOT(&gpu_buffer[act][0]);
	WaitVSync();
}

void ScreenBackground()
{
int n = 0;
int m = 0;

	

	while(m < ycursor)
	{
		while(n < MAX_XCURSOR)
		{
			FntPrint(0, n*SPACE, m*SPACE, "%c", char_buffer[n][m]);
			n++;
		}		
		n = 0;
		m++;
	}	

}

void ScreenClear()
{
	GsSetWorkBase(&gpu_buffer[act][0]);
 	GsSortClear(R, G, B);

}

void CursorCheck()
{
	
	if(ycursor >= MAX_YCURSOR) 
	{
		y = 0; 
		x = 0; 
		xcursor = 1; 
		ycursor = 1;
		Clear_Buffer();
		return;
	}
	
	if(xcursor >= MAX_XCURSOR)
	{
		x = 0;
		xcursor = 1;
		y += SPACE;
		ycursor++;
		return;
	}

	xcursor++;	
	x += SPACE;
}

void Graphic_Init()
{

	GsInitGraphQuick (X, Y);
	GsSetWorkBase(&gpu_buffer[act][0]);
	GsSortClear(R, G, B);
}


void Get_Position(int *x_pos , int *y_pos)
{
	if(x == NULL || y == NULL) return;

	*x_pos = x;
	*y_pos = y;
}

void Set_Position(int x_pos , int y_pos)
{
int update_xcursor = 0;
int update_ycursor = 0;


	update_xcursor = (x_pos / SPACE );
	update_ycursor = (y_pos / SPACE );

	if(update_xcursor == 0) xcursor = 0;
	if(update_ycursor == 0) ycursor = 0;

	if(x_pos < x)
	{
		xcursor -= (update_xcursor - xcursor);
	}
	
	if(y_pos < y)
	{
		ycursor -= (update_ycursor - ycursor);
	}

	if(x_pos > x)
	{
		xcursor += (xcursor - update_xcursor);
	}
	
	if(y_pos > y)
	{
		ycursor += (ycursor - update_ycursor);
	}

	x = x_pos;
	y = y_pos;


}

void Clear_Buffer()
{

int n = 0;
int m = 0;

	for(n = 0; n < MAX_XCURSOR ; n++)
	{
		for(m = 0; MAX_YCURSOR; m++)
		{
			char_buffer[n][m] = 0;
		}

	}

}
